#!/usr/bin/env python3
import netifaces
import urllib, urllib.parse, urllib.request, json

def locate():
	aps = {}
	try:
		from wifi import Cell
	except:
		pass
	else:
		interfaces = netifaces.interfaces()
		for interface in interfaces:
			try:
				cells = Cell.all(interface)
			except:
				pass
			else:
				for ap in cells:
					strength = [int(i) for i in ap.quality.split('/')]
					aps[ap.address] = 0-int(strength[0]/strength[1]*100)	

	try:
		import NetworkManager
		manager = NetworkManager.NetworkManager
	except:
		pass
	else:
		for dev in manager.GetDevices():
			sdev = dev.SpecificDevice()
			if sdev.__class__.__name__ == 'Wireless':
				for ap in sdev.GetAccessPoints():
					aps[ap.HwAddress] = 0-ord(ap.Strength)
				
	data = urllib.parse.urlencode([('wifi', 'mac:%s|ss:%d' % (mac, strength)) for mac, strength in aps.items()])
	f = urllib.request.urlopen('https://maps.googleapis.com/maps/api/browserlocation/json?browser=python&sensor=true&%s' % data)
	response = json.loads(f.read().decode('utf-8'))
				
	return response['location']['lat'], response['location']['lng'], response['accuracy']
		
if __name__ == '__main__':
    print(locate())
		
